/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2020,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897()  Ⱥ824575535
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		spi
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ790875685)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-4-14
 ********************************************************************************************************************/
#pragma warning disable = 47
#include <STC32G.H>

#include "zf_gpio.h"
#include "zf_spi.h"



//-------------------------------------------------------------------------------------------------------------------
//  @brief      spiʼ(ss)
//  @param      spi_n			ѡSPIģ(SPI_1-SPI_4)
//  @param      sck_pin			ѡSCK
//  @param      mosi_pin		ѡMOSI
//  @param      miso_pin		ѡMISO
//  @param     	mstr			ѡ
//  @param      mode            SPIģʽ 0CPOL=0 CPHA=0    1CPOL=0 CPHA=1   2CPOL=1 CPHA=0   3CPOL=1 CPHA=1 //ϸڿаٶ
//  @param     	baud			ѡ
//  @since      v1.0
//  Sample usage:				spi_init(SPI_CH1, 0, MASTER, SPI_SYSclk_DIV_4);	
//								//ʼSPI1,ģʽ,ΪϵͳƵ/4SPIģʽ0
//-------------------------------------------------------------------------------------------------------------------
void spi_init(SPIN_enum spi_n, u8 mode, SPI_MSTR_enum mstr, SPI_BAUD_enum baud)
{
	switch(spi_n)
    {
    case SPI_CH1:
		gpio_mode(P1_3,GPO_PP);
		gpio_mode(P1_4,GPIO);
		gpio_mode(P1_5,GPO_PP);
		P1SR |= 0x01<<3;	//GPIOΪģʽ
		P1SR |= 0x01<<4;
		P1SR |= 0x01<<5;
		P15 = 0;			//ʱ
        break;
    case SPI_CH2:
		gpio_mode(P2_3,GPO_PP);
		gpio_mode(P2_4,GPIO);
		gpio_mode(P2_5,GPO_PP);
		P2SR |= 0x01<<3;	//GPIOΪģʽ
		P2SR |= 0x01<<4;
		P2SR |= 0x01<<5;
		P25 = 0;			//ʱ
        break;
    case SPI_CH3:
		gpio_mode(P4_0,GPO_PP);
		gpio_mode(P4_1,GPIO);
		gpio_mode(P4_3,GPO_PP);
		P4SR |= 0x01<<0;	//GPIOΪģʽ
		P4SR |= 0x01<<1;
		P4SR |= 0x01<<3;
		P43 = 0;			//ʱ
        break;
    case SPI_CH4:
		gpio_mode(P3_4,GPO_PP);
		gpio_mode(P3_3,GPIO);
		gpio_mode(P3_2,GPO_PP);
		P3SR |= 0x01<<2;	//GPIOΪģʽ
		P3SR |= 0x01<<3;
		P3SR |= 0x01<<4;
		P32 = 0;			//ʱ
        break;
    }
	
	P_SW1 &= ~(0x03<<2);  //SPIܽѡλ
    switch(spi_n)
    {
    case SPI_CH1:
        P_SW1 |= (0x00<<2);
        break;
    case SPI_CH2:
        P_SW1 |= (0x01<<2);
        break;
    case SPI_CH3:
        P_SW1 |= (0x02<<2);
        break;
    case SPI_CH4:
        P_SW1 |= (0x03<<2);
        break;
    }
	
	SPCTL &= 0x00;		//SPIԺλ
	switch(mode)
	{
	case 0:
		
		break;
	case 1:
		SPCTL |= 0x01<<2;
		break;
	case 2:
		SPCTL |= 0x02<<2;
		break;
	case 3:
		SPCTL |= 0x03<<2;
		break;
	}
		
	
	SPCTL |= baud;		//趨

    if(mstr == MASTER)
    {
        SPCTL |= 1<<7;	//SSŹܣʹMSTRȷǴӻ
        SPCTL |= 1<<4;	//ģʽ
    }
    SPCTL |= 1<<6;		//ʹSPI
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      SPIͽպ
//  @param      dat          	͵
//  @since      v1.0
//  Sample usage:				buf_1 = spi_mosi(buf);    //bufݣյbuf_1Ϊ1ֽ
//-------------------------------------------------------------------------------------------------------------------
u8 spi_mosi(u8 dat)
{
    SPDAT = dat;					//DATAĴֵ
    while (!(SPSTAT & 0x80));  		//ѯɱ־
    SPSTAT |= 0xC0;                  //жϱ־
	return SPDAT;
}

