/****************************************************************************************
 *     COPYRIGHT NOTICE
 *     Copyright (C) 2023,AS DAIMXA
 *     copyright Copyright (C) DAIMXA,2023
 *     All rights reserved.
 *     QQȺ710026750
 *
 *     ע⣬ݰȨܿƼУδҵ;
 *     ޸ʱ뱣ƼİȨ
 *      ____    _    ___ __  ____  __    _    
 *     |  _ \  / \  |_ _|  \/  \ \/ /   / \   
 *     | | | |/ _ \  | || |\/| |\  /   / _ \  
 *     | |_| / ___ \ | || |  | |/  \  / ___ \ 
 *     |____/_/   \_\___|_|  |_/_/\_\/_/   \_\
 *
 * @file       dmx_icm42688.c
 * @brief      STC32F12K54Դ
 * @company    ϷʴܿƼ޹˾
 * @author     ƼQQ2453520483
 * @MCUcore    STC32F12K54
 * @Software   Keil5 C251
 * @version    鿴˵ĵversion汾˵
 * @Taobao     https://daimxa.taobao.com/
 * @Openlib    https://gitee.com/daimxa
 * @date       2023-11-10
****************************************************************************************/
#include <STC32G.H>
#include "dmx_icm42688.h"
#include "delay.h"
#include "zf_spi.h"
#include "zf_gpio.h"
#include <stdio.h>


// ICM42688ٶȼ
float icm42688_acc_x, icm42688_acc_y, icm42688_acc_z  ;       
// ICM42688Ǽٶ
float icm42688_gyro_x, icm42688_gyro_y, icm42688_gyro_z ;    

// ̬,ºΪ.cļڲ
static void Write_Data_ICM42688(unsigned char reg, unsigned char dat);
static void Read_Datas_ICM42688(unsigned char reg, unsigned char *dat, unsigned int num);
// תΪʵݵתϵ
static float icm42688_acc_inv = 1, icm42688_gyro_inv = 1; 

/**
*
* @brief    ICM42688ǳʼ
* @param
* @return   void
* @notes    û
* Example:  Init_ICM42688();
*
**/
void Init_ICM42688(void)
{
    unsigned char time;
	unsigned char model; 
	
	gpio_mode(ICM42688_CS_GPIO_PIN, GPO_PP);
	ICM42688_CS_PIN = 1;
	
		// ȡͺԼ
    model = 0xff;
    while(1)
    {
        time = 50;
        Read_Datas_ICM42688(ICM42688_WHO_AM_I, &model, 1);
        if(model == 0x47)
        {  
            // ICM42688
            break;
        }
        else
        {
            ICM42688_DELAY_MS(10);
            time--;
            if(time < 0)
            {
                while(1);
                // ԭ¼
                // ICM42688,µĸʼ
                // ߴûнӺ
            }
        }
    }
		Write_Data_ICM42688(ICM42688_PWR_MGMT0,0x00);				// λ豸
		ICM42688_DELAY_MS(10);															// PWRMGMT0Ĵ200usڲκζдĴĲ

    // ICM42688ٶȼƺǵ̺
    Set_LowpassFilter_Range_ICM42688(ICM42688_AFS_16G, ICM42688_AODR_1000HZ, ICM42688_GFS_2000DPS, ICM42688_GODR_1000HZ);

    Write_Data_ICM42688(ICM42688_PWR_MGMT0, 0x0f);      // GYRO_MODE,ACCEL_MODEΪģʽ
    ICM42688_DELAY_MS(10);
}

/**
*
* @brief    ICM42688Ǽٶ
* @param
* @return   void
* @notes    λ:g(m/s^2),û
* Example:  Get_Acc_ICM42688();
*
**/
void Get_Acc_ICM42688(void)
{
    unsigned char dat[6];
    Read_Datas_ICM42688(ICM42688_ACCEL_DATA_X1, dat, 6);
    icm42688_acc_x = icm42688_acc_inv * (short int)(((short int)dat[0] << 8) | dat[1]);
    icm42688_acc_y = icm42688_acc_inv * (short int)(((short int)dat[2] << 8) | dat[3]);
    icm42688_acc_z = icm42688_acc_inv * (short int)(((short int)dat[4] << 8) | dat[5]);
}

/**
*
* @brief    ICM42688ǽǼٶ
* @param
* @return   void
* @notes    λΪ:/s,û
* Example:  Get_Gyro_ICM42688();
*
**/
void Get_Gyro_ICM42688(void)
{
    unsigned char dat[6];
    Read_Datas_ICM42688(ICM42688_GYRO_DATA_X1, dat, 6);
    icm42688_gyro_x = icm42688_gyro_inv * (short int)(((short int)dat[0] << 8) | dat[1]);
    icm42688_gyro_y = icm42688_gyro_inv * (short int)(((short int)dat[2] << 8) | dat[3]);
    icm42688_gyro_z = icm42688_gyro_inv * (short int)(((short int)dat[4] << 8) | dat[5]);
}

/**
*
* @brief    ICM42688ǵͨ˲
* @param    afs                 // ٶȼ,dmx_icm42688.hļöٶв鿴
* @param    aodr                // ٶȼ,dmx_icm42688.hļöٶв鿴
* @param    gfs                 // ,dmx_icm42688.hļöٶв鿴
* @param    godr                // ,dmx_icm42688.hļöٶв鿴
* @return   void
* @notes    ICM42688.cļڲ,ûó
* Example:  Set_LowpassFilter_Range_ICM42688(ICM42688_AFS_16G,ICM42688_AODR_32000HZ,ICM42688_GFS_2000DPS,ICM42688_GODR_32000HZ);
*
**/
void Set_LowpassFilter_Range_ICM42688(enum icm42688_afs afs, enum icm42688_aodr aodr, enum icm42688_gfs gfs, enum icm42688_godr godr)
{
    Write_Data_ICM42688(ICM42688_ACCEL_CONFIG0, (afs << 5) | (aodr + 1));   // ʼACCEL̺(p77)
    Write_Data_ICM42688(ICM42688_GYRO_CONFIG0, (gfs << 5) | (godr + 1));    // ʼGYRO̺(p76)

    switch(afs)
    {
    case ICM42688_AFS_2G:
        icm42688_acc_inv = 2000 / 32768.0f;             // ٶȼΪ:2g
        break;
    case ICM42688_AFS_4G:
        icm42688_acc_inv = 4000 / 32768.0f;             // ٶȼΪ:4g
        break;
    case ICM42688_AFS_8G:
        icm42688_acc_inv = 8000 / 32768.0f;             // ٶȼΪ:8g
        break;
    case ICM42688_AFS_16G:
        icm42688_acc_inv = 16000 / 32768.0f;            // ٶȼΪ:16g
        break;
    default:
        icm42688_acc_inv = 1;                           // תΪʵ
        break;
    }
    switch(gfs)
    {
    case ICM42688_GFS_15_625DPS:
        icm42688_gyro_inv = 15.625f / 32768.0f;         // Ϊ:15.625dps
        break;
    case ICM42688_GFS_31_25DPS:
        icm42688_gyro_inv = 31.25f / 32768.0f;          // Ϊ:31.25dps
        break;
    case ICM42688_GFS_62_5DPS:
        icm42688_gyro_inv = 62.5f / 32768.0f;           // Ϊ:62.5dps
        break;
    case ICM42688_GFS_125DPS:
        icm42688_gyro_inv = 125.0f / 32768.0f;          // Ϊ:125dps
        break;
    case ICM42688_GFS_250DPS:
        icm42688_gyro_inv = 250.0f / 32768.0f;          // Ϊ:250dps
        break;
    case ICM42688_GFS_500DPS:
        icm42688_gyro_inv = 500.0f / 32768.0f;          // Ϊ:500dps
        break;
    case ICM42688_GFS_1000DPS:
        icm42688_gyro_inv = 1000.0f / 32768.0f;         // Ϊ:1000dps
        break;
    case ICM42688_GFS_2000DPS:
        icm42688_gyro_inv = 2000.0f / 32768.0f;         // Ϊ:2000dps
        break;
    default:
        icm42688_gyro_inv = 1;                          // תΪʵ
        break;
    }
}              

/**
*
* @brief    ICM42688д8bit
* @param    byte                
* @return   uint8_t
* @notes    ICM42688.cļڲ,ûó
* Example:  ICM42688_Write_Byte(0x00);
*
**/
static uint8_t ICM42688_Write_Byte(uint8_t byte)
{
    uint8_t dat;  

	dat = spi_mosi(byte);
	
	return dat;
}

/**
*
* @brief    ICM42688д
* @param    reg                 Ĵ
* @param    data                ҪдüĴ
* @return   void
* @notes    ICM42688.cļڲ,ûó
* Example:  Write_Data_ICM42688(0x00,0x00);
*
**/
static void Write_Data_ICM42688(unsigned char reg, unsigned char dat)
{
    ICM42688_CS_LEVEL(0);
    ICM42688_Write_Byte(reg);
    ICM42688_Write_Byte(dat);
    ICM42688_CS_LEVEL(1);
}

/**
*
* @brief    ICM42688Ƕ
* @param    reg                 Ĵ
* @param    data                Ѷݴdata
* @param    num                 ݸ
* @return   void
* @notes    ICM42688.cļڲ,ûó
* Example:  Read_Datas_ICM42688(0x00,0x00,1);
*
**/
static void Read_Datas_ICM42688(unsigned char reg, unsigned char *dat, unsigned int num)
{
    ICM42688_CS_LEVEL(0);
		reg |= 0x80;
    ICM42688_Write_Byte(reg);
    while(num--)
	{
       *dat++ = ICM42688_Write_Byte(0);
	}
    ICM42688_CS_LEVEL(1);
}