#include <STC32G.h>
#include <stdio.h>
#include <math.h>
#include "delay.h"
#include "OLED.h"
#include "zf_adc.h"
#include "zf_spi.h"
#include "zf_gpio.h"
#include "zf_uart.h"
#include "zf_tim.h"
#include "SEEKFREE_ICM20602.h"

#define DEBUG_UART 			  	UART_1
#define DEBUG_UART_BAUD 	  	115200
#define DEBUG_UART_RX_PIN  		UART1_RX_P30
#define DEBUG_UART_TX_PIN  		UART1_TX_P31
#define DEBUG_UART_TIM			TIM_2

void main(void)
{
	u16 i = 0;
	
	
	EAXFR = 1;		//ʹܷXFR
	WTST = 0;		//CPUִгٶΪ
	CKCON = 0x00;	//ⲿٶΪ
	
	uart_init(DEBUG_UART, DEBUG_UART_RX_PIN, DEBUG_UART_TX_PIN, DEBUG_UART_BAUD, DEBUG_UART_TIM);
	EA = 1;
	spi_init(SPI_CH2, 0, MASTER, SPI_SYSclk_DIV_16);
//	OLED_Init();
	adc_init(ADC_P10,ADC_SYSclk_DIV_32);
	adc_init(ADC_P11,ADC_SYSclk_DIV_32);
	adc_init(ADC_P13,ADC_SYSclk_DIV_32);
	adc_init(ADC_P14,ADC_SYSclk_DIV_32);
	adc_init(ADC_P15,ADC_SYSclk_DIV_32);
	adc_init(ADC_P16,ADC_SYSclk_DIV_32);
	adc_init(ADC_P17,ADC_SYSclk_DIV_32);
	adc_dma_init();
	
//	pit_timer_ms(TIM_0, 5);
	while(1)
	{
		adc_dma_once();
		printf("%d, %d, %d, %d, %d, %d, %d\n", adc_fir_val[0], adc_fir_val[1], adc_fir_val[2], adc_fir_val[3], adc_fir_val[4], adc_fir_val[5], adc_fir_val[6]);
		delay_ms(200);
//		delay_ms(500);
	}
}

void TM0_Isr() interrupt 1 
{

}

char putchar(char c)
{
	uart_putchar(DEBUG_UART, c);//ԼʵֵĴڴӡһֽݵĺ滻

	return c;
}