/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2020,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897()  Ⱥ824575535
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		adc
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ790875685)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-4-14
 ********************************************************************************************************************/
#include <STC32G.H>


#include "zf_adc.h"

#define M 	 	7U		//ͨ
#define N		4U		//ת

uint8_t xdata adc_val[M * (2 * N + 3) + M] = {0};
uint16_t adc_fir_val[7] = {0};

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ADCʼ
//  @param      adcn            ѡADCͨ
//  @param      speed      		ADCʱƵ
//  @return     void
//  Sample usage:               adc_init(ADC_P10,ADC_SYSclk_DIV_2);//ʼP1.0ΪADC,ADCʱƵʣSYSclk/2
//-------------------------------------------------------------------------------------------------------------------
void adc_init(ADCN_enum adcn,ADC_SPEED_enum speed)
{
	ADC_CONTR |= 1<<7;				//1  ADC Դ
	
	ADC_CONTR &= (0xF0);			//ADC_CHS[3:0]  ADC ģͨѡλ
	ADC_CONTR |= adcn;
	
	if((adcn >> 3) == 1) //P0.0
	{
		//IOҪΪ
		P0M0 &= ~(1 << (adcn & 0x07));
		P0M1 |= (1 << (adcn & 0x07));
	}
	else if((adcn >> 3) == 0) //P1.0	
	{
		//IOҪΪ
		P1M0 &= ~(1 << (adcn & 0x07));
	    P1M1 |= (1 << (adcn & 0x07));
	}

	ADCCFG |= speed&0x0F;			//ADCʱƵSYSclk/2/speed&0x0F;
	
	ADCCFG |= 1<<5;					//תҶ롣 ADC_RES ĸ 2 λ ADC_RESL ĵ 8 λ
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      ADCתһ
//  @param      adcn            ѡADCͨ
//  @param      resolution      ֱ
//  @return     void
//  Sample usage:               adc_convert(ADC_P10, ADC_10BIT);
//-------------------------------------------------------------------------------------------------------------------
u16 adc_once(ADCN_enum adcn)
{
	u16 adc_value;
	
	ADC_CONTR &= (0xF0);			//ADC_CHS[3:0]  ADC ģͨѡλ
	ADC_CONTR |= adcn;
	
	ADC_CONTR |= 0x40;  			//  AD ת
	while (!(ADC_CONTR & 0x20));  	// ѯ ADC ɱ־
	ADC_CONTR &= ~0x20;  			// ɱ־
	
	adc_value = ADC_RES;  			//洢 ADC  12 λĸ 4 λ
	adc_value <<= 8;
	adc_value |= ADC_RESL;  		//洢 ADC  12 λĵ 8 λ
	
	return adc_value;
}

void adc_dma_init(void)
{
	DMA_ADC_CFG = 0;
	DMA_ADC_CFG |= 0x03;		//رжϣȼΪ
	
	DMA_ADC_CR = 0x80;			//ʹDMA
	
	DMA_ADC_STA &= 0xFE;		//жϱ־

	DMA_ADC_RXAL = (uint8_t)&adc_val;		//adcתŵַΪ xdata 
	DMA_ADC_RXAH = (uint16_t)&adc_val>>8;
	
	DMA_ADC_CFG2 = 0x09;		//ת4
	
	DMA_ADC_CHSW0 = 0xFB;		//תͨ0134567
	DMA_ADC_CHSW1 = 0x00;
}

void adc_dma_once(void)
{
	uint8_t i = 0;
	
	DMA_ADC_CR |= 0x40;			//ʼDMAת
	
	while(!(DMA_ADC_STA & 0x01));//ȴת
	
	DMA_ADC_STA = 0x00;		//жϱ־
	
	for(i = 0 ; i < M; i++)
	{
		adc_fir_val[i]  = adc_val[(i + 1) * (2 * N + 3) - 1 + i];
		adc_fir_val[i] <<= 8;
		adc_fir_val[i] |= adc_val[(i + 1) * (2 * N + 3) + i];
	}
}